@echo off
setlocal enableextensions

set SourceDir=%~pd0
if defined ProgramW6432 (
  set SourceKFW=kfw-amd64-3-2-2.msi
  set SourceNIM=netidmgr-AMD64-rel-2_0_102_907.msi
  set SourceAFS=yfs-openafs-en_US-AMD64-1_7_3301.msi
  set SourceMST=openafs_tuc_3301_x64.mst
  set MsiFeatureRemoveNIM="Feature.KeyStore,Feature.KeyStore.Debug,Feature.Krb5.Debug,Feature.Core.Debug"
) else (
  set SourceKFW=kfw-i386-3-2-2.msi
  set SourceNIM=netidmgr-i386-rel-2_0_102_907.msi
  set SourceAFS=yfs-openafs-en_US-i386-1_7_3301.msi
  set SourceMST=openafs_tuc_3301_x86.mst
  set MsiFeatureRemoveNIM="Feature.Krb4,Feature.Krb4.Debug,Feature.KeyStore,Feature.KeyStore.Debug,Feature.Krb5.Debug,Feature.Core.Debug"
)

rem try to delete invalid settings of current user
taskkill /F /IM "netidmgr.exe" >NUL 2>NUL
for /f "tokens=7 delims=\" %%i in ('reg query "HKEY_CURRENT_USER\Software\MIT\NetIDMgr\KCDB\Identity"') do reg delete "HKEY_CURRENT_USER\Software\MIT\NetIDMgr\KCDB\Identity\%%i\AfsCred" /v "Cells" /f >NUL 2>NUL
for /f "tokens=7 delims=\" %%i in ('reg query "HKEY_CURRENT_USER\Software\MIT\NetIDMgr\KCDB\Identity"') do reg delete "HKEY_CURRENT_USER\Software\MIT\NetIDMgr\KCDB\Identity\%%i\AfsCred\Cells\TU-CHEMNITZ.DE" /f >NUL 2>NUL
reg delete "HKEY_CURRENT_USER\Software\MIT\NetIDMgr\PluginManager\Plugins\AfsCred\Cells" /v "TU-CHEMNITZ.DE" /f >NUL 2>NUL
reg delete "HKEY_CURRENT_USER\Software\MIT\NetIDMgr\PluginManager\Plugins\AfsCred\Parameters" /v "LRUCells" /f >NUL 2>NUL

echo === Installieren von KFW 3.2.2 ===
echo.
msiexec.exe /qn /i "%SourceDir%kfw\%SourceKFW%" /Liew "%TEMP%\kfw.install.log" REBOOT=ReallySuppress
copy /b /y "%SourceDir%krb5.ini" "%SystemRoot%\"
if defined ProgramW6432 (
  copy /b /y "%SourceDir%kfw\patched64\leashw64.dll" "%ProgramFiles%\MIT\Kerberos\bin\"
  copy /b /y "%SourceDir%kfw\patched64\kfwlogon.dll" "%SystemRoot%\System32\"
  copy /b /y "%SourceDir%kfw\patched64\kfwcpcc.exe"  "%SystemRoot%\System32\"
  copy /b /y "%SourceDir%kfw\compat32\comerr32.dll"  "%ProgramFiles%\MIT\Kerberos\bin\"
  copy /b /y "%SourceDir%kfw\compat32\gssapi32.dll"  "%ProgramFiles%\MIT\Kerberos\bin\"
  copy /b /y "%SourceDir%kfw\compat32\k5sprt32.dll"  "%ProgramFiles%\MIT\Kerberos\bin\"
  copy /b /y "%SourceDir%kfw\compat32\kclnt32.dll"   "%ProgramFiles%\MIT\Kerberos\bin\"
  copy /b /y "%SourceDir%kfw\compat32\krb524.dll"    "%ProgramFiles%\MIT\Kerberos\bin\"
  copy /b /y "%SourceDir%kfw\compat32\krb5_32.dll"   "%ProgramFiles%\MIT\Kerberos\bin\"
  copy /b /y "%SourceDir%kfw\compat32\krbcc32.dll"   "%ProgramFiles%\MIT\Kerberos\bin\"
  copy /b /y "%SourceDir%kfw\compat32\krbv4w32.dll"  "%ProgramFiles%\MIT\Kerberos\bin\"
  copy /b /y "%SourceDir%kfw\compat32\leashw32.dll"  "%ProgramFiles%\MIT\Kerberos\bin\"
  copy /b /y "%SourceDir%kfw\compat32\wshelp32.dll"  "%ProgramFiles%\MIT\Kerberos\bin\"
  copy /b /y "%SourceDir%kfw\compat32\xpprof32.dll"  "%ProgramFiles%\MIT\Kerberos\bin\"
  copy /b /y "%SourceDir%kfw\compat32\msvcr71.dll"   "%ProgramFiles%\MIT\Kerberos\bin\"
  reg add "HKLM\SOFTWARE\Wow6432Node\MIT\Kerberos" /v "InstallDir" /t "REG_SZ" /d "%ProgramFiles%\MIT\Kerberos\\" /f
) else (
  reg delete "HKLM\SOFTWARE\MIT\NetIDMgr\PluginManager\Modules\MITKrb4" /f
  reg delete "HKLM\SOFTWARE\MIT\NetIDMgr\PluginManager\Plugins\Krb4Cred" /f
  del /f /q "%ProgramFiles%\MIT\Kerberos\bin\krb4cred.dll"
  del /f /q "%ProgramFiles%\MIT\Kerberos\bin\krb4cred_en_us.dll"
  del /f /q "%ProgramFiles%\MIT\Kerberos\bin\leash32.chm"
  del /f /q "%ProgramFiles%\MIT\Kerberos\bin\leash32.exe"
)

echo === Installieren von NIM 2.0 ===
echo.
msiexec.exe /qn /i "%SourceDir%nim\%SourceNIM%" /Liew "%TEMP%\nim.install.log" ADDLOCAL=ALL REMOVE=%MsiFeatureRemoveNIM% REBOOT=ReallySuppress
regedit /s "%SourceDir%nim.reg"

echo === Installieren von OpenAFS 1.7.33.01 ===
echo.
sc query TransarcAFSDaemon | findstr "STATE" | findstr "RUNNING" >NUL 2>NUL
if %errorlevel% == 0 (
  echo Stoppe TransarcAFSDaemon ...
  sc stop TransarcAFSDaemon
  sleep 10
)
if exist %SystemRoot%\Temp\AFSCache (
  attrib -S -H %SystemRoot%\Temp\AFSCache
  del /f /q    %SystemRoot%\Temp\AFSCache
)
msiexec.exe /qn /i "%SourceDir%openafs\%SourceAFS%" /Liew "%TEMP%\afs.install.log" TRANSFORMS="%SourceDir%%SourceMST%" REBOOT=ReallySuppress
sc failure TransarcAFSDaemon reset= 600 actions= restart/5000/restart/10000/restart/60000
regedit /s "%SourceDir%openafs.reg"
reg add "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\TransarcAFSDaemon\Parameters" /v "VolumeInfoReadOnlyFlag" /t "REG_DWORD" /d "0" /f
rem make sure that the afs cell name is lowercase
reg add "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\TransarcAFSDaemon\Parameters" /v "Cell" /t "REG_SZ" /d "tu-chemnitz.de" /f

echo === Abschluss der Installation ===
echo.
if exist "%ALLUSERSPROFILE%\Start Menu\Programs\Kerberos for Windows (64-bit)" rmdir /s /q "%ALLUSERSPROFILE%\Start Menu\Programs\Kerberos for Windows (64-bit)"
if exist "%ALLUSERSPROFILE%\Start Menu\Programs\Kerberos for Windows (32-bit)" rmdir /s /q "%ALLUSERSPROFILE%\Start Menu\Programs\Kerberos for Windows (32-bit)"
if exist "%ALLUSERSPROFILE%\Start Menu\Programs\Network Identity Manager"      rmdir /s /q "%ALLUSERSPROFILE%\Start Menu\Programs\Network Identity Manager"
if exist "%ALLUSERSPROFILE%\Start Menu\Programs\OpenAFS"                       rmdir /s /q "%ALLUSERSPROFILE%\Start Menu\Programs\OpenAFS"

echo Reboot nach Installation ...
shutdown /r /t 30 /c "Neustart nach Softwareinstallation (OpenAFS) erforderlich."

endlocal
echo.
echo Fertig. Automatischer Neustart erfolgt in 30 Sekunden!
